{-# LANGUAGE ForeignFunctionInterface #-}
module Main(main) where

import System.Environment
import Foreign
import Foreign.C

type HandlerHS  = CInt -> CInt -> IO CInt
type HandlerC   = CInt -> CInt -> StablePtr HandlerHS -> IO CInt

foreign import ccall "event_loop"
  eventLoop :: IO ()

foreign import ccall "install_handler"
  installHandler :: FunPtr HandlerC -> StablePtr HandlerHS -> IO ()

--------------------------------------------------------------------------------

foreign import ccall "static_wrapper"
  staticImportAddr :: HandlerHS

--------------------------------------------------------------------------------

foreign export ccall "run_handler"
  runHandler :: HandlerC

foreign import ccall "&run_handler"
  exportAddr :: FunPtr HandlerC

runHandler :: HandlerC
runHandler x y p =
  do f <- deRefStablePtr p
     f x y

--------------------------------------------------------------------------------


main :: IO ()
main =
  do h : _ <- getArgs
     let addr | h == "export"         = exportAddr
              | h == "static_wrapper" = staticImportAddr
              | otherwise             = error "invalid test"

     user <- newStablePtr (\x y -> return (x + y))
     installHandler addr user
     eventLoop



